class SystemeParticules
{
  ArrayList particules;
  ArrayList contraintes;
  int nbIterations;
  Vector2 delta;
  
  // ------------------------
  SystemeParticules(){
    this.particules = new ArrayList();
    this.contraintes = new ArrayList();
    this.delta = new Vector2();
    this.nbIterations = 5;
  }

  // ------------------------
  Particule ajouteParticule(Particule P){
    this.particules.add(P);
    return P;
  }
  
  // ------------------------
  Contrainte ajouteContrainte(Contrainte C){
    this.contraintes.add(C);
    return C;
  }

  // ------------------------
  void maj(float dt){
    accumulationForces();
    majParticules(dt);
    resoutContraintes();
  }

  // ------------------------
  void accumulationForces(){
      Iterator itP = this.particules.iterator();
      Particule p;
      while(itP.hasNext()){
        p = (Particule) itP.next();
        p.acceleration.set(g);      
      }  
  }

  // ------------------------
  void resoutContraintes(){
    for (int i=0;i<this.nbIterations;i++){
      
      // Contraintes 1
      // chaque particule doit rester dans la fenêtre de dessin
      Iterator itP = this.particules.iterator();
      Particule p;
      while(itP.hasNext()){
        p = (Particule) itP.next();
        p.contrainteMonde();
      }
      
      // Contrainte 2
      // chaque liaison (=distance) entre les particules doit être respectée
      Iterator itC = this.contraintes.iterator();
      Contrainte c;
      while(itC.hasNext()){
        c = (Contrainte) itC.next();
        
        Vector2 posA = c.A.position; 
        Vector2 posB = c.B.position; 
        this.delta.x = posB.x - posA.x;
        this.delta.y = posB.y - posA.y;
        float deltaLength = dist(posA.x,posA.y,posB.x,posB.y);
        float diff = (deltaLength - c.longueurRepos) / deltaLength;

        posA.x += this.delta.x*0.5*diff;        
        posA.y += this.delta.y*0.5*diff;        

        posB.x -= this.delta.x*0.5*diff;        
        posB.y -= this.delta.y*0.5*diff;        
       
      }
  }
  
  }

  // ------------------------
  void majParticules(float dt){
      Iterator itP = this.particules.iterator();
      Particule p;
      while(itP.hasNext()){
        p = (Particule) itP.next();
        p.maj(dt);
      }
  }

  // ------------------------
  void dessine(){
      // Contraintes en premier
      Iterator itC = this.contraintes.iterator();
      Contrainte c;
      while(itC.hasNext()){
        c = (Contrainte) itC.next();
        c.dessine();
      }
        
      // Particules en premier
      noStroke();
      Iterator itP = this.particules.iterator();
      Particule p;
      while(itP.hasNext()){
        p = (Particule) itP.next();
        p.dessine();
      }
  }
};
